use std::io;

fn recurse_through_c_files(dir: &str) -> io::Result<()> {
    let dir = std::fs::read_dir(dir)?;

    for file in dir {
        let file = file?;
 
        let file_path = file.path();

        if file.path().is_dir() {
            recurse_through_c_files(file_path.to_str()
                     .expect("filepath should be converted to string slice"))?;
        }

        let ext = file_path.extension()
            .and_then(|v| v.to_str())
            .unwrap_or_else(|| "");

        if ext != "c" {
            continue;
        }

        println!("{:?}", file.path().with_extension("o").file_name().expect("files should have names"));
        todo!()
    }

    Ok(())
}

fn main() {
    recurse_through_c_files(".").unwrap_or_else(|e| {
        panic!("error: could not recurse through directory: {e}");
    });
}
